var formidable 	= require('formidable');

module.exports = function(server, callback) {
	//use formidable
	var methods = {},
		query 	= [], 
		files 	= [], 
		form 	= new formidable.IncomingForm();
	
	form.onPart = function(part) {
		//part can be any type of request
		//the only one we care about is requests
		//that are file uploads
		if(!part.filename || !part.mime) {
			//let formidable handle this
			form.handlePart(part);
			return;
		}
		
		var meta = { 
			key		: part.name, 
			name	: part.filename, 
			mime	: part.mime };
		
		files.push(meta);
		
		server.trigger('file-start', meta);
		
		part.addListener('data', function() {
			//just pass it along
			var args = Array.prototype.slice.apply(arguments);
			args.unshift(meta);
			args.unshift('file-data');
			server.trigger.apply(server, args);
		});
		
		part.addListener('end', function() {
			//just pass it along
			var args = Array.prototype.slice.apply(arguments);
			args.unshift(meta);
			args.unshift('file-end');
			server.trigger.apply(server, args);
		}.bind(this));
	};
	
	//collect the fields
	form.on('field', function(name, value) {
		query.push(name + '=' + value);
	}).on('end', function() {
		callback.call(server, query.join('&'), files);
	});
	
	return form;
};