var string		= require('eden-string');
var form		= require('./form');
var process		= require('./process');

module.exports = function(https, server) {
	return function(request, response) {
		//add post and get method
		//on request object
		request.post = https.request;
		request.get  = https.get;
		
		//start in good conscience
		response.state 		= 200;
		response.headers 	= { 'Content-Type': 'text/html' };
		response.encoding	= 'utf-8';
		
		//parse out the URL
		request.path 		= string().toPath(request.url);
		request.pathArray	= string().pathToArray(request.url);
		request.query 		= string().pathToQuery(request.url);
		
		request.files		= [];
		request.message 	= '';
		
		var _process = process(server);
		
		server.trigger('request-start', request, response);
		
		//if this is a form submit
		if(typeof request.headers === 'object'
		&& typeof request.headers['content-type'] === 'string'
		&& request.headers['content-type'].indexOf('multipart/form-data') === 0) {
			form(server, function(fields, files) {
				request.message = fields;
				request.files 	= files
				_process(request, response);
			}).parse(request);
			
			return;
		}
		
		request.on('data', function(data) {
			request.message += data;
			
			//Prevent FLOOD ATTACK, FAULTY CLIENT, NUKE REQUEST
			if(request.message.length > 1e6) {
				request.message = '';
				response.writeHead(413, {'Content-Type': 'text/plain'});
				response.end();
				request.connection.destroy();
			}
		});
		
		request.on('end', function() {
			//console.log(request);
			_process(request, response);
		});
	};
};