module.exports = function(https, server) {
	return function(request, response) {
		var message = '';
		
		if(response.message) {
			message = response.message.toString();
		}
		
		if(response.state === 404) {
			server.trigger('response-404', request, response);
		}
		
		try {
			response.writeHead(response.state, response.headers);
			
			response.end(message, response.encoding);
			
			//event trigger
			server.trigger('output', request, response);
		} catch(error) {
			response.state = 500;
			//event trigger
			server.trigger('output-error', request, response, error);
			
			if(!message.length) {
				response.message = error.toString();
			}
			
			response.writeHead(response.state, response.headers);
			response.end(response.message);
		}
	};
};